﻿/***********************************************************************************
* PROJECT: ASP_NET_check_db_oracle                                                 *
* AUTHOR: Alan Pipitone                                                            *
* DATE: 22/05/2012                                                                 *
* WEBSITE: http://www.alan-pipitone.com/                                           *
*                                                                                  *
* NB: This software has no warranty                                                *
************************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Data;
using System.Data.OracleClient;

namespace ASP_NET_check_db_oracle
{
    class CheckDataBase
    {
        private string connectionString = "";
        private string dataSource = "";

        public CheckDataBase(string connStringArg)
        {
            //save the connection string
            connectionString = connStringArg;
        }

        public TimeSpan getPerformance(string query)
        {
            //load the connection string
            OracleConnection conn = new OracleConnection(connectionString);
            //set the query
            OracleCommand cmd = new OracleCommand(query);
            //save the datasource
            dataSource = conn.DataSource;
            //to save the performance
            TimeSpan elapsedTime = new TimeSpan();
            Stopwatch sw = Stopwatch.StartNew();

            try
            {
                //if query isn't a select then exit
                if (query.ToLower().IndexOf("select ") == -1 |
                    query.ToLower().IndexOf("create ") != -1 |
                    query.ToLower().IndexOf("alter ") != -1 |
                    query.ToLower().IndexOf("update ") != -1 |
                    query.ToLower().IndexOf("insert ") != -1)
                {
                    Console.WriteLine("ERROR: Only SELECT statement can be used!");
                    Environment.Exit(2);
                }

                sw = Stopwatch.StartNew();

                //open the connection
                conn.Open();

                //set the options for the command
                cmd.Connection = conn;
                cmd.CommandType = CommandType.Text;

                //execute the query
                OracleDataReader reader = cmd.ExecuteReader();

                //if (reader.HasRows == true)
                //{
                //    //success
                //}

                sw.Stop();
                elapsedTime = sw.Elapsed;
            }
            catch(Exception ex)
            {
                //print the exception
                Console.WriteLine("Error with database: " + ex.Message + " data source: " + dataSource);
                Environment.Exit(2);
            }
            finally
            {

                cmd.Dispose();
                conn.Close();
                sw.Stop();
            }

            return elapsedTime;
        }

        public string getDataSource()
        {
            return dataSource;
        }
    }
}
